#version 330
#extension GL_EXT_gpu_shader4 : enable
// Sin wave texture_1Mod01.fsh by chenxiaoleizi
//https://www.shadertoy.com/view/fdt3zl
// Licence CC0
// Adapted, trivialy, for use in VGHD player
/////////////////////////////////////////////
uniform float u_Elapsed;    // The elapsed time in seconds
uniform vec2  u_WindowSize; // Window dimensions in pixels

#define iTime u_Elapsed*0.314159  //*0.1666
#define iResolution u_WindowSize

//#define mouse AUTO_MOUSE
//#define MOUSE_SPEED vec2(vec2(0.5,0.577777) * 0.25)
//#define MOUSE_POS   vec2((1.0+cos(iTime*MOUSE_SPEED))*u_WindowSize/2.0)
//#define MOUSE_PRESS vec2(0.0,0.0)
//#define AUTO_MOUSE  vec4( MOUSE_POS, MOUSE_PRESS )
//#define RIGID_SCROLL
// alternatively use static mouse definition
#define iMouse vec4(0.0,0.0, 0.0,0.0)
//#define iMouse vec4(512,256,180,120)
uniform sampler2D iChannel0;
uniform sampler2D iChannel1;
uniform sampler2D iChannel2;
uniform sampler2D iChannel3;
vec4 texture2D_Fract(sampler2D sampler,vec2 P) {return texture2D(sampler,fract(P));}
vec4 texture2D_Fract(sampler2D sampler,vec2 P, float Bias) {return texture2D(sampler,fract(P),Bias);}
#define texture2D texture2D_Fract
void main (void)
//void mainImage( out vec4 fragColor, in vec2 fragCoord )
{
    // Normalized pixel coordinates (from 0 to 1)
    vec2 uv = gl_FragCoord.xy/iResolution.y;
    vec2 st = uv - 0.5;
    
    float timeOffset = iTime*0.1; 
    float d = 1.0 - length(st);
    float theta = atan(st.x, st.y);
    float frequency = 6.0, amplitude = 0.1;
    
    float sinUv = d + sin(theta * frequency)*amplitude + timeOffset;
    sinUv = mod(sinUv, 10.0);
    
    // Sample texture
    vec3 col = texture2D(iChannel0, vec2(sinUv)).xyz;

    // Output to screen
    gl_FragColor = vec4(col,1.0);
}